package tools.descartes.prisma.agent.wildfly.interceptors.jms;

import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Queue;
import javax.jms.Topic;

import tools.descartes.prisma.agent.wildfly.callstack.ComponentRecord;
import tools.descartes.prisma.agent.wildfly.callstack.InterfaceRecord;
import tools.descartes.prisma.agent.wildfly.callstack.InvocationGroupRecord;
import tools.descartes.prisma.agent.wildfly.callstack.OperationRecord;
import tools.descartes.prisma.agent.wildfly.service.MonitoringService;

public class MessageInterceptor {
	
	public static void intercept(Destination destination) {
		String destinationName = null;		
		try {
			if (destination instanceof Queue) {
				destinationName = ((Queue)destination).getQueueName();
			} else if (destination instanceof Topic) {
				destinationName = ((Topic)destination).getTopicName();
			}
			if (destinationName != null) {
				ComponentRecord crec = MonitoringService.INSTANCE.getTraceRoot().requireComponent(destinationName);
				if (crec.getComponentClass() == null) {
					crec.setComponentClass(destination.getClass().getName());
				}
				InterfaceRecord irec = crec.requireInterface("javax.jms.MessageProducer");
				OperationRecord orec = irec.requireOperation("send");
				InvocationGroupRecord grec = orec.requireInvocationGroup(0);
				grec.addInvocation(0, 0, 0);
			}
		} catch (JMSException e) {
			e.printStackTrace();
		}		
	}
}
