package tools.descartes.prisma.core.commands;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.Repository;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryComponent;

public abstract class AddComponentCommand<E extends RepositoryComponent> extends ModelCommand<RepositoryComponent> {
	
	private final String componentName;

	public AddComponentCommand(String componentName) {
		this.componentName = componentName;
	}

	@Override
	public E apply(CommandContext ctx) {
		Repository repository = ctx.getRepository();
		RepositoryComponent component = find(repository.getComponents(), componentName);
		if (component == null) {
			component = createRepositoryComponent();
			component.setId("Component_" + getId(componentName));
			component.setName(componentName);
			repository.getComponents().add(component);
		}
		return (E)component;
	}
	
	protected abstract E createRepositoryComponent();
	
	public String getComponentName() {
		return componentName;
	}
}
