package tools.descartes.prisma.core.commands;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.Interface;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Repository;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryFactory;

public class AddInterfaceCommand extends ModelCommand<Interface> {
	
	private final String interfaceName;	

	public AddInterfaceCommand(String interfaceName) {
		this.interfaceName = interfaceName;
	}

	@Override
	public Interface apply(CommandContext ctx) {
		Repository repository = ctx.getRepository();
		Interface curInterface = find(repository.getInterfaces(), interfaceName);
		if (curInterface == null) {
			curInterface = RepositoryFactory.eINSTANCE.createInterface();
			curInterface.setId("Interface_" + getId(interfaceName));
			curInterface.setName(interfaceName);
			repository.getInterfaces().add(curInterface);
		}
		return curInterface;
	}
}
