package tools.descartes.prisma.core.commands;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.Interface;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryComponent;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryFactory;

public class AddInterfaceProvidingRoleCommand extends ModelCommand<InterfaceProvidingRole> {
	
	private final String portName;
	private final AddComponentCommand addComponent;
	private final AddInterfaceCommand addInterface;	

	public AddInterfaceProvidingRoleCommand(String portName, AddComponentCommand addComponent, AddInterfaceCommand addInterface) {
		this.portName = portName;
		this.addComponent = addComponent;
		this.addInterface = addInterface;
	}

	@Override
	public InterfaceProvidingRole apply(CommandContext ctx) {
		Interface interf = addInterface.apply(ctx);
		RepositoryComponent component = addComponent.apply(ctx);
		
		String name = component.getName() + "#Prov:" + interf.getName();
		if (!portName.isEmpty()) {
			name = name + ":" + portName;
		}
		InterfaceProvidingRole providingRole = find(component.getInterfaceProvidingRoles(), name);
		if (providingRole == null) {
			providingRole = RepositoryFactory.eINSTANCE.createInterfaceProvidingRole();
			providingRole.setName(name);
			providingRole.setInterface(interf);
			component.getInterfaceProvidingRoles().add(providingRole);
		}
		return providingRole;
	}

}
