package tools.descartes.prisma.core.commands;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.Interface;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceRequiringRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryComponent;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryFactory;

public class AddInterfaceRequiringRoleCommand extends ModelCommand<InterfaceRequiringRole> {

	private final String portName;
	private final AddComponentCommand addComponent;
	private final AddInterfaceCommand addInterface;

	public AddInterfaceRequiringRoleCommand(AddComponentCommand addComponent, AddInterfaceCommand addInterface, String portName) {
		this.portName = portName;
		this.addComponent = addComponent;
		this.addInterface = addInterface;
	}

	@Override
	public InterfaceRequiringRole apply(CommandContext ctx) {
		Interface interf = addInterface.apply(ctx);
		RepositoryComponent component = addComponent.apply(ctx);
		
		String name = component.getName() + "#Req:" + interf.getName();
		if (!portName.isEmpty()) {
			name = name + ":" + portName;
		}
		InterfaceRequiringRole requiringRole = find(component.getInterfaceRequiringRoles(), name);
		if (requiringRole == null) {
			requiringRole = RepositoryFactory.eINSTANCE.createInterfaceRequiringRole();
			requiringRole.setName(name);
			requiringRole.setInterface(interf);
			component.getInterfaceRequiringRoles().add(requiringRole);
		}
		return requiringRole;
	}

}
