package tools.descartes.prisma.core.commands;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.Interface;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryFactory;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature;

public class AddSignatureCommand extends ModelCommand<Signature> {
	
	private final String signatureName;
	private final AddInterfaceCommand addInterface;

	public AddSignatureCommand(String signatureName, AddInterfaceCommand addInterface) {
		this.signatureName = signatureName;
		this.addInterface = addInterface;
	}

	@Override
	public Signature apply(CommandContext ctx) {
		Interface curInterface = addInterface.apply(ctx);
		Signature signature = getSignature(curInterface);
		if (signature == null) {
			signature = RepositoryFactory.eINSTANCE.createSignature();
			signature.setId("Signature_" + getId(signatureName));
			signature.setName(signatureName);
			curInterface.getSignatures().add(signature);
		}
		return signature;
	}
	
	private Signature getSignature(Interface intf) {
		for (Signature sig : intf.getSignatures()) {
			if (sig.getName().equals(signatureName)) {
				return sig;
			}
		}
		return null;
	}

}
