package tools.descartes.prisma.core.commands;

import java.util.Collection;

import org.eclipse.emf.ecore.EObject;

import edu.kit.ipd.descartes.core.NamedElement;

public abstract class ModelCommand<E extends EObject> {
	
	public abstract E apply(CommandContext ctx);
	
	protected String getId(String name) {
		return name.replace("/", "_").replace(":", "_").replace(".",  "_").replace("#", "_").replace(" ", "_");
	}
	
	protected <T extends NamedElement> T find(Collection<T> collection, String name) {
		for (T cur : collection) {
			if (cur.getName().equals(name)) {
				return cur;
			}
		}
		return null;
	}
	
}
